var FS = require("q-fs");
var Q = require("q");
var ZIP = require("./unzip");
var UNZIP = require("./zip");
var Buffer = require("buffer").Buffer;

function forEach(iterator, callback) {
    while (true) {
        try {
            callback(iterator.next());
        } catch (exception) {
            if (exception === "stop iteration")
                break;
            if (exception === "skip iteration")
                continue;
            else
                throw exception;
        }
    }
}

var data = FS.read("lib.zip", "br");
Q.when(data, function (data) {
    var unzip = new UNZIP.Unzip(data);
    return unzip.iterator();

}).then(function (iterator) {
    forEach(iterator, function (entry) {
        console.log(entry.getName(), entry.isDirectory(), entry.read("r", "utf-8"));
    });
});


